/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel  
 *
 *  Copyright (C) 2008-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: nios2.h 89 2009-01-25 16:02:00Z ertl-honda $
 */

/*
 *  Nios2Υϡɥ񸻤
 */

#ifndef TOPPERS_NIOS2_H
#define TOPPERS_NIOS2_H

#include <sil.h>

/*
 *  ߥӥå
 */
#define STATUS_U   0x02
#define STATUS_PIE 0x01

/*
 * ߤο
 */
#define MAX_INT_NUM 32

/*
 * 㳰θĿ
 */
#define MAX_EXC_NUM 32

/*
 * ߥϥɥֹ椫顤IRCΤΥӥåȥѥޥ
 */
#define INTNO_BITPAT(intno) (1U << intno)

/*
 * Mutex
 */ 
#define MUTEX_MUTEX_OFFSET 0x00
#define MUTEX_RESET_OFFSET 0x04

#define MUTEX_MUTEX_OWNER_MASK   0xffff0000
#define MUTEX_MUTEX_VALUE_MASK   0x0000ffff
#define MUTEX_MUTEX_OWNER_OFFSET (16U)

#define MUTEX_RESET_RESET_MASK   0x01
#define MUTEX_VALUE_DATA         0x1234

#ifndef TOPPERS_MACRO_ONLY
#include "prc_insn.h"

/*
 *  ץåINDEX0ꥸˤμ
 *  ˳ƥץå0Ϣ³ͤꤷƤ 
 */
Inline uint32_t
x_prc_index(void)
{
	return(current_cpuid());
}

/*
 *  MutexϢ
 */

/*
 *  Mutexμ
 *  ǤtrueǤʤfalse֤ 
 */ 
Inline int
mutex_try_lock(uint32_t addr, uint32_t id)
{
	uint32_t data;
	uint32_t check;
    
	data = (id << MUTEX_MUTEX_OWNER_OFFSET) | MUTEX_VALUE_DATA;

	sil_wrw_mem((void *)(addr + MUTEX_MUTEX_OFFSET), data);
	check = sil_rew_mem((void *)(addr + MUTEX_MUTEX_OFFSET));

	return (data == check)? true : false;
}

/*
 *  Mutexβ 
 */ 
Inline void
mutex_unlock(uint32_t addr, uint32_t id)
{
	sil_wrw_mem((void *)(addr + MUTEX_MUTEX_OFFSET), (id << MUTEX_MUTEX_OWNER_OFFSET));
}

/*
 *  Mutexν
 */
Inline void
mutex_init(uint32_t addr)
{
	uint32_t data;
	uint32_t check;

	check = sil_rew_mem((void *)(addr + MUTEX_RESET_OFFSET));

	if ( check == MUTEX_RESET_RESET_MASK ){
		sil_wrw_mem((void *)(addr + MUTEX_RESET_OFFSET), MUTEX_RESET_RESET_MASK);
	}
	else {
		data = sil_rew_mem((void *)(addr + MUTEX_MUTEX_OFFSET));
		sil_wrw_mem((void *)(addr + MUTEX_MUTEX_OFFSET), (data & MUTEX_MUTEX_OWNER_MASK));
	}
}
#endif /* TOPPERS_MACRO_ONLY */

#endif /* TOPPERS_MICROBLAZE_H */
